package cn.com.mjsoft.cms.metadata.api;


import cn.com.mjsoft.cms.common.spring.annotation.ActionInfo;
import cn.com.mjsoft.cms.metadata.service.DictService;
import cn.com.mjsoft.framework.util.StringUtil;
import cn.com.mjsoft.framework.web.wing.ServletUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Map;


/**
 *
 * @author mj-soft
 *
 */
@ResponseBody
@RestController
@RequestMapping( "/japi" )
public class ClientDicWordlApi
{
    @Autowired
    private DictService dictService;

    @ResponseBody
    @RequestMapping( value = "/dic-word", method = { RequestMethod.POST, RequestMethod.GET} )
    @ActionInfo( api = true, traceName = "字典信息")
    public Object executeBiz( HttpServletRequest request, HttpServletResponse response ) throws Exception
    {
        Map params = ServletUtil.getRequestDecodeInfo( request );

//        Map<String, String> msg = new HashMap<String, String>();

        String typeFlag = StringUtil.notNull( ( String ) params.get( "type" ) );

        String dicFlag = StringUtil.notNull( ( String ) params.get( "flag" ) );

        if(StringUtil.isStringNotNull(dicFlag))
        {
            return dictService.retrieveSingleDicWord(dicFlag);
        }

        return dictService.retrieveDicWordsList(typeFlag);
    }

}