package cn.com.mjsoft.cms.metadata.controller;

import cn.com.mjsoft.cms.common.spring.annotation.ActionInfo;
import cn.com.mjsoft.cms.metadata.service.DictService;
import cn.com.mjsoft.framework.util.StringUtil;
import cn.com.mjsoft.framework.web.wing.ServletUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
@RequestMapping( "/metadata" )
public class ManageDictWordController
{
    @Autowired
    private DictService dictService;
    
    @ResponseBody
    @RequestMapping( value = "/getDicWord.do", method = { RequestMethod.GET } )
    public Object getDicWord(HttpServletRequest request, HttpServletResponse response )
    {
        Map params = ServletUtil.getRequestInfo( request );

        String typeFlag = (String) params.get( "typeFlag" );

        String pval = (String) params.get( "val" );

        return dictService.retrieveChildDicWordsOptList( typeFlag, pval );
    }

    @ResponseBody
    @RequestMapping( value = "/addDicType.do", method = { RequestMethod.POST } )
    @ActionInfo( traceName = "添加字典主类型", token = true )
    public Object addDicType( HttpServletRequest request, HttpServletResponse response )
    {
        Map params = ServletUtil.getRequestDecodeInfo( request );

        String typeName = (String) params.get( "dicTypeName" );

        String flag = (String) params.get( "flag" );

        dictService.addDicType( typeName, flag );

        return "success";
    }

    @ResponseBody
    @RequestMapping( value = "/editDicType.do", method = { RequestMethod.POST } )
    @ActionInfo( traceName = "编辑字典主类型", token = true )
    public Object editDicType( HttpServletRequest request, HttpServletResponse response )
    {
        Map params = ServletUtil.getRequestDecodeInfo( request );

        String typeName = (String) params.get( "dicTypeName" );

        String flag = (String) params.get( "flag" );

        dictService.editDicType( typeName, flag );

        return "success";
    }


    @ResponseBody
    @RequestMapping( value = "/addDicWord.do", method = { RequestMethod.POST } )
    @ActionInfo( traceName = "添加字典词", token = true )
    public Object addDicWord( HttpServletRequest request, HttpServletResponse response )
    {
        Map params = ServletUtil.getRequestInfo( request );

        String dicType = (String) params.get("dicType");

        dictService.addDicWord( params );

        Map paramMap = new HashMap();

        paramMap.put( "dicType", dicType );

        paramMap.put( "fromFlow", Boolean.TRUE );

        return ServletUtil.redirect( "/core/words/create-dic-word.thtml", paramMap );
    }

    @ResponseBody
    @RequestMapping( value = "/editDicWord.do", method = { RequestMethod.POST } )
    @ActionInfo( traceName = "编辑字典词", token = true )
    public Object editDicWord( HttpServletRequest request, HttpServletResponse response )
    {
        Map params = ServletUtil.getRequestInfo( request );

        String dicFlag = (String) params.get("dicFlag");

        String name = (String) params.get("dicWord");

        String val = (String) params.get("val");

        dictService.editDicWord( dicFlag, name, val);

        Map paramMap = new HashMap();

        paramMap.put( "dicFlag", dicFlag );

        paramMap.put( "fromFlow", Boolean.TRUE );

        return ServletUtil.redirect( "/core/words/edit-dic-word.thtml", paramMap );
    }

    @ResponseBody
    @RequestMapping( value = "/deleteDicWord.do", method = { RequestMethod.POST } )
    @ActionInfo( traceName = "删除字典词", token = true )
    public Object deleteDicWord( HttpServletRequest request, HttpServletResponse response )
    {
        Map params = ServletUtil.getRequestInfo( request );

        List idList = StringUtil.changeStringToList( ( String ) params.get( "ids" ), "," );

        dictService.deleteDicWordAndChildDic( idList );

        return "success";
    }

    @ResponseBody
    @RequestMapping( value = "/deleteDicWordByType.do", method = { RequestMethod.POST } )
    @ActionInfo( traceName = "主分类删除字典词", token = true )
    public Object deleteDicWordByType( HttpServletRequest request, HttpServletResponse response )
    {
        Map params = ServletUtil.getRequestInfo( request );

        String dicType = (String) params.get("dicType");

        dictService.deleteDicWordByLinear( dicType );

        dictService.deleteDicMainType( dicType );

        return "success";
    }

    @ResponseBody
    @RequestMapping( value = "/importDW.do", method = { RequestMethod.POST } )
    @ActionInfo( traceName = "导入字典词", token = true )
    public Object importDW( HttpServletRequest request, HttpServletResponse response )
    {
        Map params = ServletUtil.getRequestDecodeInfo( request );

        String dWords = (String) params.get("dword");

        String dicType = (String) params.get("dicType");

        dictService.importDicWord( dicType, dWords );

        return "success";
    }


}
